#include "datafilereader_msc.h"

// declare class
DataFileReader_MSC DataFile;

int main(int argc, char *argv[], char *env[])
{
  // declare local variables
  void * pvoidHeader;
  void * pvoidData;

  char * pcharHeader;
  char * pcharData;


  if (argc == 2)
  {
    if (!DataFile.LoadDataFile_DFR(argv[1]))
    {
      // set local header pointers
      pvoidHeader = DataFile.GetHeaderPointer_DFR();
      pcharHeader = (char*)pvoidHeader;

      // find data section
      pcharData = strstr(pcharHeader, "DATA");

      // update local & DataFileReader data pointers
      pvoidData = (void*)pcharData;
      DataFile.SetDataPointer_DFR(pvoidData);

      // print data section to console
      cout << pcharData;
    }
    else
    {
      // error loading file
      cout << "Dooh!!";
    }
  }

  return (0);
}

