
#if !defined(DATAFILEREADER_MSC_INCLUDED)
#define DATAFILEREADER_MSC_INCLUDED

#define FILE_OK_DFR          0
#define ERROR_FILE_LOAD_DFR -1
#define ERROR_FILE_SEEK_DFR -2
#define ERROR_FILE_OPEN_DFR -3

#if !defined(STDIO_INCLUDED)
#include "stdio.h"
#endif

#if !defined(IOSTREAM_INCLUDED)
#include "iostream.h"
#endif

#define _ThisClass      DataFileReader_MSC
#define _NumBaseClass   0


class DataFileReader_MSC
{
  public:

    DataFileReader_MSC();
    DataFileReader_MSC(
        char * pcharFileName);
    virtual ~DataFileReader_MSC();
    void * GetDataPointer_DFR();
    unsigned long GetFileSize_DFR();
    void * GetHeaderPointer_DFR();
    int LoadDataFile_DFR(
        char * pcharFileName);
    void SetDataPointer_DFR(
        void *pvoidStart);
    void SetHeaderPointer_DFR(
        void *pvoidStart);

  private:
    void * pvoid_FileBuffer;
    void * pvoid_DataStart;
    void * pvoid_HeaderStart;
    unsigned long ul_FileSize;
    void InitializeDataFileReaderClass_DFR();
};

#undef _ThisClass
#undef _NumBaseClass

#endif  // DATAFILEREADER_MSC_INCLUDED
